/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	64
#define	CHRHEIGHT	32
#define	MAXCHARA	80

void	convpic(int picsize_x,int picsize_y,int chrcnt,unsigned char c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],unsigned char pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	unsigned char	pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	unsigned char	c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		cnum;
	int		size;
	int		chr_width,chr_height;
	int		offset;

	if (argc != 6) {
		fprintf(stderr, "Usage: convchara infile outfile offset size cha_number\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	offset = atoi(argv[3]);
	size = atoi(argv[4]);
	cnum = atoi(argv[5]);

	fseek(infp,4+offset,SEEK_SET);

	switch (size) {
		case 2:
			chr_width  = 16;
			chr_height =  8;
			break;
		case 3:
			chr_width  = 32;
			chr_height = 16;
			break;
		case 4:
			chr_width  = 64;
			chr_height = 32;
			break;
		default:
			fprintf(stderr,"Illigal size %d : size = 2-4\n",size);
			exit(1);
	}


	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < chr_height;y ++) {
			for (x = 0;x < chr_width;x ++) {
				pixel[x][y][z] = 0x00;
			}
		}
	}


	z = 0;
	y = 0;
	x = 0;
	c = 0x09;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= chr_width) {
			x = 0;
			y ++;
			if (y >= chr_height) {
				y = 0;
				if (c == 0x09) {
					c = 0x0a;
				} else {
					c = 0x09;
					z ++;

					if (z >= cnum) {
						break;
					}
				}
			}
		}
	}

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < chr_height;y ++) {
			for (x = 0;x < chr_width;x ++) {
				switch (pixel[x][y][z]) {
					case 0x08: pixel[x][y][z] = 0x00;break;
					case 0x09: pixel[x][y][z] = 0x01;break;
					case 0x0a: pixel[x][y][z] = 0x03;break;
					case 0x0b: pixel[x][y][z] = 0x02;break;
					default:   pixel[x][y][z] = 0x07;break;
				}
			}
		}
	}

	convpic(chr_width,chr_height,MAXCHARA,c_pixel,pixel);

	for (z = 0;z < cnum;z ++) {

		for (x = 0;x < chr_width/2;x += 8) {
			for (y = 0;y < chr_height;y ++) {

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((c_pixel[x+i][y][z] & 0x01) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);
				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((c_pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

			}
		}


		for (y = 0;y < chr_height;y ++) {
			a1 = 0;
			x = chr_width/2-8;
			for (i = 4;i < 8;i ++) {
				a0 = ( ((c_pixel[x+i][y][z] & 0x01) != 0x00) ? 0x01 : 0x00);
				a1 = a1 * 2 + a0;
			}
			x = 0;
			for (i = 0;i < 4;i ++) {
				a0 = ( ((c_pixel[x+i][y][z] & 0x01) != 0x00) ? 0x01 : 0x00);
				a1 = a1 * 2 + a0;
			}
			fputc(a1,outfp);

			a1 = 0;
			x = chr_width/2-8;
			for (i = 4;i < 8;i ++) {
				a0 = ( ((c_pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
				a1 = a1 * 2 + a0;
			}
			x = 0;
			for (i = 0;i < 4;i ++) {
				a0 = ( ((c_pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
				a1 = a1 * 2 + a0;
			}
			fputc(a1,outfp);
		}


		for (x = 4;x < chr_width/2-8;x += 8) {
			for (y = 0;y < chr_height;y ++) {
				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((c_pixel[x+i][y][z] & 0x01) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);
				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((c_pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);
			}
		}

	}


	fclose(outfp);
	fclose(infp);

	return(0);
}


void	convpic(int picsize_x,int picsize_y,int chrcnt,unsigned char c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],unsigned char pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA])
{
	int		x,y,z;

	unsigned char	c_pixel_tmp[CHRWIDTH/2][CHRHEIGHT];

	for (z = 0;z < chrcnt;z ++) {

		for (y = 0;y < picsize_y;y ++) {
			for (x = 0;x < picsize_x/2;x ++) {
				c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
			}

			if (picsize_x == 16) {
				continue;
			}

			for (x = 0;x < picsize_x/2 - 2;x ++) {
				if (
					(pixel[x*2+0][y][z] == pixel[x*2+2][y][z]) && 
					(pixel[x*2+1][y][z] == pixel[x*2+3][y][z])
				) {
					if ( (x%2) == 0) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
					} else {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+0][y][z];
					}
				}
			}
			for (;x < picsize_x/2;x ++) {
				if (
					(pixel[x*2-2+0][y][z] == pixel[x*2-2+2][y][z]) && 
					(pixel[x*2-2+1][y][z] == pixel[x*2-2+3][y][z])
				) {
					if ( (x%2) == 0) {
						c_pixel[x+0][y][z] = pixel[x*2-2+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-2+1][y][z];
					} else {
						c_pixel[x+0][y][z] = pixel[x*2-2+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-2+0][y][z];
					}
				}
			}

			for (x = 0;x < picsize_x/2 - 4;x ++) {
				if (
					(pixel[x*2+0][y][z] == pixel[x*2+4][y][z]) && 
					(pixel[x*2+1][y][z] == pixel[x*2+5][y][z]) &&
					(pixel[x*2+2][y][z] == pixel[x*2+6][y][z]) && 
					(pixel[x*2+3][y][z] == pixel[x*2+7][y][z])
				) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+2][y][z] = pixel[x*2+2][y][z];
						c_pixel[x+3][y][z] = pixel[x*2+3][y][z];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y][z] = pixel[x*2+3][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+2][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+3][y][z] = pixel[x*2+2][y][z];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
						c_pixel[x+2][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+3][y][z] = pixel[x*2+1][y][z];
					} else {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
						c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
						c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
					}
				}
			}
			for (;x < picsize_x/2;x ++) {
				if (
					(pixel[x*2-4+0][y][z] == pixel[x*2-4+4][y][z]) && 
					(pixel[x*2-4+1][y][z] == pixel[x*2-4+5][y][z]) &&
					(pixel[x*2-4+2][y][z] == pixel[x*2-4+6][y][z]) && 
					(pixel[x*2-4+3][y][z] == pixel[x*2-4+7][y][z])
				) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y][z] = pixel[x*2-4+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-4+1][y][z];
						c_pixel[x+2][y][z] = pixel[x*2-4+2][y][z];
						c_pixel[x+3][y][z] = pixel[x*2-4+3][y][z];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y][z] = pixel[x*2-4+3][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-4+0][y][z];
						c_pixel[x+2][y][z] = pixel[x*2-4+1][y][z];
						c_pixel[x+3][y][z] = pixel[x*2-4+2][y][z];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y][z] = pixel[x*2-4+2][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-4+3][y][z];
						c_pixel[x+2][y][z] = pixel[x*2-4+0][y][z];
						c_pixel[x+3][y][z] = pixel[x*2-4+1][y][z];
					} else {
						c_pixel[x+0][y][z] = pixel[x*2-4+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2-4+2][y][z];
						c_pixel[x+2][y][z] = pixel[x*2-4+3][y][z];
						c_pixel[x+3][y][z] = pixel[x*2-4+0][y][z];
					}
				}
			}

		}

	}

	return;
}


